package com.sf.msg.consumers;

package ..deTemp.1735199928061;

import com.sf.msg.bean.AlarmMsgBean;
import com.sf.msg.bean.SmsPlanBean;
import com.sf.msg.bean.SmsProcessBean;
import com.sf.msg.service.DmsMessageSendService;
import com.sf.msg.service.SmsWxRestParaHandler;
import com.sf.web.dms.common.ws.handler.MessageConsumer;
import com.smartframework.web.core.http.HttpResponse;
import com.smartframework.web.core.http.IParaHandler;
import com.smartframework.web.core.utils.ClientFactory;
import com.smartframework.web.core.utils.Constants;
import com.smartframework.web.core.utils.DateUtil;
import com.smartframework.web.core.utils.IMSenderUtil;
import com.smartframework.web.core.utils.JdbcClient;
import com.smartframework.web.core.utils.JsonUtil;
import com.smartframework.web.core.utils.ParameterUtils;
import com.smartframework.web.core.utils.RestClient;
import com.smartframework.web.core.utils.RthdbDao;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;

public class SmsMessageConsumer extends MessageConsumer {
  static Logger logger = Logger.getLogger(com.sf.msg.consumers.SmsMessageConsumer.class);
  
  static ConcurrentHashMap<String, Integer> brkStatusMap = null;
  
  static ConcurrentHashMap<String, List<String>> tableSubsMap = null;
  
  static SmsProcessBean smsProcessBean = new SmsProcessBean();
  
  static ConcurrentHashMap<String, String> headerBrkMap = null;
  
  static boolean isInit = false;
  
  public SmsMessageConsumer() {
    createJdbcClient();
    createRthdbDao();
  }
  
  public static String loadCurOrg(JdbcClient paramJdbcClient, Integer paramInteger) {
    String str = "select id from sys_organization start with id in(select org_id from sys_org_user_link where user_id=";
    str = str + paramInteger + ") connect by prior id = pid order by id";
    List list = paramJdbcClient.queryForList(str);
    ArrayList<String> arrayList = new ArrayList();
    arrayList.add("-1");
    for (Map map : list)
      arrayList.add(String.valueOf(map.get("id"))); 
    return StringUtils.join(arrayList, ",");
  }
  
  public static List<String> loadDevsByFeeder(JdbcClient paramJdbcClient, String paramString, Integer paramInteger) {
    ArrayList<String> arrayList = new ArrayList();
    loadDevsReaction(paramJdbcClient, "con_feeder", paramString, "", paramInteger, arrayList);
    return arrayList;
  }
  
  public static List<String> loadDevsByStstion(JdbcClient paramJdbcClient, String paramString, Integer paramInteger) {
    ArrayList<String> arrayList = new ArrayList();
    Integer integer = Constants.getInteger("dms.sms.auth", Integer.valueOf(0));
    if (integer.intValue() == 0) {
      loadDevsReaction(paramJdbcClient, "con_station", paramString, "", paramInteger, arrayList);
    } else {
      List list = paramJdbcClient.queryForList("select distinct id from con_feeder where container_id=" + paramString + " and id in(select container_id from auth_orgrtu where org_id in(" + loadCurOrg(paramJdbcClient, paramInteger) + "))");
      for (Map map : list) {
        String str = String.valueOf(map.get("id"));
        loadDevsReaction(paramJdbcClient, "con_feeder", str, "", paramInteger, arrayList);
      } 
      for (String str : tableSubsMap.get("con_station")) {
        if (str == "con_feeder")
          continue; 
        list = new ArrayList();
        list = paramJdbcClient.queryForList("select id from " + str + " where container_id=" + paramString);
        for (Map map : list) {
          String str1 = String.valueOf(map.get("id"));
          loadDevsReaction(paramJdbcClient, str, str1, "", paramInteger, arrayList);
        } 
      } 
    } 
    return arrayList;
  }
  
  public static List<String> loadDevsByFilter(JdbcClient paramJdbcClient, String paramString, Integer paramInteger) {
    ArrayList<String> arrayList = new ArrayList();
    if (ParameterUtils.isEmptyOrNull(paramString))
      return arrayList; 
    Integer integer = Constants.getInteger("dms.sms.auth", Integer.valueOf(0));
    String str = "";
    if (integer.intValue() == 0) {
      str = "select id from obj_dev where filter='" + paramString + "'";
      List list = paramJdbcClient.queryForList(str);
      for (Map map : list) {
        String str1 = String.valueOf(map.get("id"));
        if (arrayList.contains(str1))
          continue; 
        arrayList.add(str1);
      } 
    } else {
      str = "select container_id from auth_orgrtu where org_id in(" + loadCurOrg(paramJdbcClient, paramInteger) + ")";
      List list = paramJdbcClient.queryForList(str);
      for (Map map : list) {
        String str1 = String.valueOf(map.get("containerId"));
        loadDevsReaction(paramJdbcClient, "con_feeder", str1, paramString, paramInteger, arrayList);
      } 
    } 
    return arrayList;
  }
  
  public static void loadDevsReaction(JdbcClient paramJdbcClient, String paramString1, String paramString2, String paramString3, Integer paramInteger, List<String> paramList) {
    String str = "select id,filter from obj_dev where container_id=" + paramString2;
    if (!ParameterUtils.isEmptyOrNull(paramString3))
      str = "select id,filter from obj_dev where container_id=" + paramString2 + " and filter='" + paramString3 + "'"; 
    List list = paramJdbcClient.queryForList(str);
    for (Map map : list) {
      String str1 = String.valueOf(map.get("id"));
      if (paramList.contains(str1))
        continue; 
      String str2 = String.valueOf(map.get("filter"));
      if (!ParameterUtils.isEmptyOrNull(paramString3) && str2 != paramString3)
        continue; 
      paramList.add(str1);
    } 
    if (!tableSubsMap.containsKey(paramString1))
      return; 
    for (String str1 : tableSubsMap.get(paramString1)) {
      List list1 = paramJdbcClient.queryForList("select id from " + str1 + " where container_id=" + paramString2);
      for (Map map : list1) {
        String str2 = String.valueOf(map.get("id"));
        if (!paramList.contains(str2))
          paramList.add(str2); 
        loadDevsReaction(paramJdbcClient, str1, str2, paramString3, paramInteger, paramList);
      } 
    } 
  }
  
  public static void loadContainer(JdbcClient paramJdbcClient, Integer paramInteger, SmsProcessBean paramSmsProcessBean) {
    if (!paramSmsProcessBean.getUserStations().containsKey(paramInteger))
      paramSmsProcessBean.getUserStations().put(paramInteger, new ArrayList()); 
    if (!paramSmsProcessBean.getUserFeeders().containsKey(paramInteger))
      paramSmsProcessBean.getUserFeeders().put(paramInteger, new ArrayList()); 
    List list = paramJdbcClient.queryForList("select container_id,station_id from auth_orgrtu where org_id in(" + loadCurOrg(paramJdbcClient, paramInteger) + ")");
    for (Map map : list) {
      if (ParameterUtils.isEmptyOrNull(map.get("containerId")))
        continue; 
      String str = String.valueOf(map.get("containerId"));
      if (!((List)paramSmsProcessBean.getUserFeeders().get(paramInteger)).contains(str))
        ((List<String>)paramSmsProcessBean.getUserFeeders().get(paramInteger)).add(str); 
      if (!ParameterUtils.isEmptyOrNull(map.get("stationId"))) {
        String str1 = String.valueOf(map.get("stationId"));
        if (!((List)paramSmsProcessBean.getUserStations().get(paramInteger)).contains(str1))
          ((List<String>)paramSmsProcessBean.getUserStations().get(paramInteger)).add(str1); 
      } 
    } 
  }
  
  public static List<String> loadPhone(JdbcClient paramJdbcClient, Integer paramInteger) {
    ArrayList<String> arrayList = new ArrayList();
    Integer integer = Constants.getInteger("dms.sms.phone.source", Integer.valueOf(0));
    if (integer.intValue() == 0) {
      List list = paramJdbcClient.queryForList("select phone from sms_phone_user_link where user_id=" + paramInteger);
      for (Map map : list) {
        String str = String.valueOf(map.get("phone"));
        if (ParameterUtils.isEmptyOrNull(str) || str
          .length() < 11 || arrayList
          .contains(str))
          continue; 
        arrayList.add(str);
      } 
      list = paramJdbcClient.queryForList("select phone from sys_web_user where id=" + paramInteger);
      for (Map map : list) {
        String str = String.valueOf(map.get("phone"));
        if (ParameterUtils.isEmptyOrNull(str) || str
          .length() < 11 || arrayList
          .contains(str))
          continue; 
        arrayList.add(str);
      } 
    } else if (integer.intValue() == 1) {
      List list = paramJdbcClient.queryForList("select distinct phone from sys_web_user where id in(select distinct user_id from sys_org_user_link where org_id in(" + loadCurOrg(paramJdbcClient, paramInteger) + "))");
      for (Map map : list) {
        String str = String.valueOf(map.get("phone"));
        if (ParameterUtils.isEmptyOrNull(str) || str
          .length() < 11 || arrayList
          .contains(str))
          continue; 
        arrayList.add(str);
      } 
    } else {
      List list1 = paramJdbcClient.queryForList("select phone from sms_phone_user_link where user_id=" + paramInteger);
      for (Map map : list1) {
        String str1 = String.valueOf(map.get("phone"));
        if (ParameterUtils.isEmptyOrNull(str1) || str1
          .length() < 11 || arrayList
          .contains(str1))
          continue; 
        arrayList.add(str1);
      } 
      String str = "select distinct phone from sys_web_user where id in(select distinct user_id from sys_org_user_link where org_id in(" + loadCurOrg(paramJdbcClient, paramInteger) + "))";
      List list2 = paramJdbcClient.queryForList(str);
      for (Map map : list2) {
        String str1 = String.valueOf(map.get("phone"));
        if (ParameterUtils.isEmptyOrNull(str1) || str1
          .length() < 11 || arrayList
          .contains(str1))
          continue; 
        arrayList.add(str1);
      } 
    } 
    return arrayList;
  }
  
  public static synchronized void reLoad() {
    JdbcClient jdbcClient = ClientFactory.getInstance().getJdbcClient();
    RthdbDao rthdbDao = ClientFactory.getInstance().getRthdbClient();
    isInit = false;
    if (ParameterUtils.isEmptyOrNull(brkStatusMap))
      brkStatusMap = new ConcurrentHashMap<>(); 
    brkStatusMap.clear();
    ArrayList arrayList = new ArrayList();
    List list = rthdbDao.queryForList("select id,status from real_scada_obj_dev where filter in('breaker')");
    for (Map map : list) {
      String str3 = String.valueOf(map.get("id"));
      String str4 = String.valueOf(map.get("status"));
      Integer integer = Integer.valueOf(0);
      String str5 = Integer.toBinaryString(Integer.valueOf(str4).intValue());
      if (str5.length() >= 13 && str5.charAt(12) == '0')
        integer = Integer.valueOf(1); 
      brkStatusMap.put(str3, integer);
    } 
    logger.info(String.format("Fa开关总共%d个", new Object[] { Integer.valueOf(brkStatusMap.size()) }));
    if (ParameterUtils.isEmptyOrNull(headerBrkMap))
      headerBrkMap = new ConcurrentHashMap<>(); 
    headerBrkMap.clear();
    list = rthdbDao.queryForList("select id,head_brk from real_scada_con_feeder");
    for (Map map : list) {
      String str3 = String.valueOf(map.get("id"));
      String str4 = String.valueOf(map.get("headBrk"));
      headerBrkMap.put(str4, str3);
    } 
    logger.info(String.format("馈线首开关总共%d个", new Object[] { Integer.valueOf(headerBrkMap.size()) }));
    if (ParameterUtils.isEmptyOrNull(tableSubsMap)) {
      tableSubsMap = new ConcurrentHashMap<>();
      tableSubsMap.clear();
      HashMap<Object, Object> hashMap = new HashMap<>();
      list = new ArrayList();
      list = jdbcClient.queryForList("select name,tablename from con_1_description where tablename like 'con_%'");
      for (Map map : list) {
        String str3 = String.valueOf(map.get("name"));
        String str4 = String.valueOf(map.get("tablename"));
        if (str3.equals("division") || str3.equals("convertorend") || str3.equals("company") || str3
          .equals("bay") || str3.equals("convertor"))
          continue; 
        hashMap.put(str3, str4);
      } 
      for (String str3 : hashMap.keySet()) {
        String str4 = (String)hashMap.get(str3);
        list = new ArrayList();
        String str5 = "";
        Integer integer = Constants.getInteger("dms.sms.dbtype", Integer.valueOf(5));
        if (integer.intValue() == 4) {
          str5 = "WITH RECURSIVE r AS (SELECT * FROM con_1_relation WHERE containername='" + str3;
          str5 = str5 + "' union ALL SELECT con_1_relation.* FROM con_1_relation, r WHERE con_1_relation.containername = r.membername) SELECT membername FROM r ORDER BY id";
        } else {
          str5 = "select membername from con_1_relation start with containername='" + str3;
          str5 = str5 + "' connect by prior membername = containername order by id";
        } 
        list = jdbcClient.queryForList(str5);
        for (Map map : list) {
          String str6 = String.valueOf(map.get("membername"));
          String str7 = (String)hashMap.get(str6);
          if (str6.equals("division") || str6.equals("convertorend") || str6.equals("company") || str6
            .equals("bay") || str6.equals("convertor"))
            continue; 
          if (!tableSubsMap.containsKey(str4))
            tableSubsMap.put(str4, new ArrayList<>()); 
          if (((List)tableSubsMap.get(str4)).contains(str7))
            continue; 
          ((List<String>)tableSubsMap.get(str4)).add(str7);
        } 
      } 
    } 
    String str1 = Constants.getString("dms.msg.sms.handler.watch.types", "");
    if (ParameterUtils.isEmptyOrNull(str1))
      str1 = ""; 
    boolean bool = false;
    smsProcessBean.clear();
    list = new ArrayList();
    String str2 = "select a.alarm_type,a.status,a.infer_name,b.device_type,b.expired_date,b.is_enabled,b.send_plan,b.template_id,c.user_id from sms_alarm_type_def a,sms_alarm_dev_type_link b,sms_sub_dev_link c where a.id=b.alarm_type and b.id=c.alarm_dev_link_id";
    list = jdbcClient.queryForList(str2);
    for (Map map : list) {
      String str3 = String.valueOf(map.get("alarmType"));
      String str4 = String.valueOf(map.get("status"));
      String str5 = String.format("%s.%s", new Object[] { str3, str4 });
      String str6 = "";
      if (!ParameterUtils.isEmptyOrNull(map.get("inferName")))
        str6 = String.valueOf(map.get("inferName")); 
      String str7 = String.valueOf(map.get("deviceType"));
      Integer integer1 = Integer.valueOf(1);
      if (!ParameterUtils.isEmptyOrNull(map.get("isEnabled")))
        integer1 = Integer.valueOf(String.valueOf(map.get("isEnabled"))); 
      Integer integer2 = Integer.valueOf(1);
      if (!ParameterUtils.isEmptyOrNull(map.get("sendPlan")))
        integer2 = Integer.valueOf(String.valueOf(map.get("sendPlan"))); 
      integer2 = Integer.valueOf(1);
      if (ParameterUtils.isEmptyOrNull(map.get("templateId"))) {
        logger.info(String.format("告警类型:%s,设备类型:%s 的短信模板为空，当前订阅信息无效，涉及到的设备将无法发送短信", new Object[] { str5, str7 }));
        continue;
      } 
      String str8 = String.valueOf(map.get("templateId"));
      Integer integer3 = Integer.valueOf(String.valueOf(map.get("userId")));
      if (!smsProcessBean.getUserPhones().containsKey(integer3))
        smsProcessBean.getUserPhones().put(integer3, loadPhone(jdbcClient, integer3)); 
      if (!smsProcessBean.getUserFeeders().containsKey(integer3))
        loadContainer(jdbcClient, integer3, smsProcessBean); 
      SmsPlanBean smsPlanBean = smsProcessBean.loadOnePlan(str5, integer2, str8, integer3);
      smsPlanBean.setPostfix(str6);
      Long long_ = Long.valueOf(System.currentTimeMillis());
      if (str7.startsWith("1021")) {
        if (!smsPlanBean.getDevs().contains(str7))
          smsPlanBean.getDevs().add(str7); 
      } else if (!smsPlanBean.getdTypes().contains(str7)) {
        smsPlanBean.getdTypes().add(str7);
      } 
      if (smsProcessBean.getAlmTypeDevs().containsKey(str5))
        for (String str : smsProcessBean.getAlmTypeDevs().get(str5)) {
          if (smsPlanBean.getDevs().contains(str))
            continue; 
          smsPlanBean.getDevs().add(str);
        }  
      for (String str : smsProcessBean.getUserPhones().get(integer3)) {
        if (smsPlanBean.getPhones().contains(str))
          continue; 
        smsPlanBean.getPhones().add(str);
      } 
    } 
    logger.info(String.format("订阅列表个数：%d", new Object[] { Integer.valueOf(smsProcessBean.getSubMap().size()) }));
    for (String str : smsProcessBean.getSubMap().keySet()) {
      bool = (str1.indexOf(str) > -1) ? true : false;
      List list1 = (List)smsProcessBean.getSubMap().get(str);
      if (bool)
        logger.info(String.format("订阅%s,涉及%d个发送方式", new Object[] { str, Integer.valueOf(list1.size()) })); 
      for (SmsPlanBean smsPlanBean : list1) {
        logger.debug(String.format("短信类型:%s,短信模板:%s,发送计划:%d，用户:%d，涉及发送短信人员:%s, 涉及要发送短信的设备类型:%s,已经读取的设备个数:%d", new Object[] { str, smsPlanBean
                .getTemplate_id(), smsPlanBean.getSend_plan(), smsPlanBean.getUser_id(), smsPlanBean.getPhones().toString(), StringUtils.join(smsPlanBean.getdTypes(), ","), Integer.valueOf(smsPlanBean.getDevs().size()) }));
      } 
    } 
    try {
      jdbcClient.close();
    } catch (Exception exception) {
      logger.warn("关闭JDBC连接时异常，可能出现内存泄漏。");
    } 
    try {
      rthdbDao.close();
    } catch (Exception exception) {
      logger.warn("关闭RTHDB连接时异常，可能出现内存泄漏。");
    } 
    isInit = true;
  }
  
  public String getOrgCode() {
    if (Constants.integerConfigIsEnabled("dms.sms.load.alarm"))
      return ""; 
    return Constants.getAppPrefixedPara("orgCode");
  }
  
  public void handleMsg() throws Exception {
    String str = getTopic();
    Map<String, Object> map = getData();
    if (!"alarm_listen".equals(getTopic())) {
      logger.info("MSGDATA,消息主题不是alarm_listen");
      return;
    } 
    logger.debug("收到短信可以处理的消息，topic:" + getTopic());
    logger.debug("-----------------测试测试测试------------------------------------");
    handle(map);
  }
  
  public void handle(Map<String, Object> paramMap) {
    String str1 = Constants.getString("dms.msg.sms.handler.watch.types");
    if (ParameterUtils.isEmptyOrNull(str1))
      str1 = ""; 
    boolean bool = false;
    String str2 = Constants.getString("dms.msg.sms.handler.watch.devIds");
    if (ParameterUtils.isEmptyOrNull(str2))
      str2 = ""; 
    List<AlarmMsgBean> list = extractAlarmFromMsgContentNew(paramMap);
    HashMap<Object, Object> hashMap = new HashMap<>();
    for (AlarmMsgBean alarmMsgBean : list) {
      if (!alarmMsgBean.isValid())
        continue; 
      ((List<AlarmMsgBean>)hashMap.computeIfAbsent(alarmMsgBean.subKey(), paramString -> new ArrayList())).add(alarmMsgBean);
    } 
    for (Map.Entry<Object, Object> entry : hashMap.entrySet()) {
      String str = (String)entry.getKey();
      List list1 = (List)entry.getValue();
      bool = (str1.indexOf(str) > -1) ? true : false;
      if (!smsProcessBean.getSubMap().containsKey(str)) {
        if (bool)
          logger.info(String.format("告警:SubKey:%s 不在订阅列表", new Object[] { str })); 
        continue;
      } 
      StringBuilder stringBuilder = new StringBuilder();
      for (AlarmMsgBean alarmMsgBean : list1)
        stringBuilder.append(alarmMsgBean.getAlarm_str()).append("\n"); 
      List list2 = (List)smsProcessBean.getSubMap().get(str);
      for (SmsPlanBean smsPlanBean : list2) {
        if (ParameterUtils.isEmptyOrNull(smsPlanBean.getPhones())) {
          if (bool)
            logger.info(String.format("订阅信息中没有有效订阅人，SubKey:%s", new Object[] { str })); 
          continue;
        } 
        String str3 = "alm-sms-" + ParameterUtils.getUUID().toLowerCase();
        ArrayList<String> arrayList = new ArrayList();
        for (String str7 : smsPlanBean.getPhones())
          arrayList.add(str7); 
        HashMap<Object, Object> hashMap1 = new HashMap<>();
        hashMap1.put("reciveDate", DateUtil.format(Long.valueOf(System.currentTimeMillis())));
        hashMap1.put("content", stringBuilder.toString());
        hashMap1.put("fileName", str3);
        hashMap1.put("fileFolder", getOrgCode());
        if (bool)
          logger.info(String.format("发送计划[用户:%d, 短信模板:%s], 合并后的告警内容:\n%s", new Object[] { smsPlanBean
                  .getUser_id(), smsPlanBean.getTemplate_id(), stringBuilder.toString() })); 
        String str4 = Constants.getAppPrefixedPara("message.service.url", "local");
        String str5 = "";
        String str6 = String.format("%s %s", new Object[] { hashMap1.get("reciveDate"), hashMap1.get("content") });
        if (str4.equals("local")) {
          try {
            (new DmsMessageSendService()).send(hashMap1, str6, arrayList);
          } catch (Exception exception) {
            str5 = "写本地短信文件时异常" + hashMap1.get("fileName");
            logger.warn(str5, exception);
          } finally {
            WriteSendLog(arrayList, (Map)hashMap1, str5, String.valueOf(smsPlanBean.getSend_plan()), smsPlanBean.getTemplate_id());
          } 
          continue;
        } 
        if (str4.equals("webservice")) {
          try {
            SmsWxRestParaHandler smsWxRestParaHandler = new SmsWxRestParaHandler();
            RestClient restClient = new RestClient(SmsWxRestParaHandler.baseUrl);
            restClient.assembleParaHandler((IParaHandler)smsWxRestParaHandler);
            HashMap<Object, Object> hashMap2 = new HashMap<>();
            hashMap2.put("fileStr", smsWxRestParaHandler.encrypt(String.valueOf(hashMap1.get("content")), arrayList));
            try {
              HttpResponse httpResponse = restClient.get("/fa/sendMessage", new HashMap<>(), hashMap2);
              WriteSendLog(arrayList, (Map)hashMap1, str5, String.valueOf(smsPlanBean.getSend_plan()), smsPlanBean.getTemplate_id());
            } catch (Exception exception) {
              str5 = exception.getMessage();
              WriteSendLog(arrayList, (Map)hashMap1, str5, String.valueOf(smsPlanBean.getSend_plan()), smsPlanBean.getTemplate_id());
            } 
          } catch (Exception exception) {
            str5 = "写本地短信文件时异常" + hashMap1.get("fileName");
            WriteSendLog(arrayList, (Map)hashMap1, str5, String.valueOf(smsPlanBean.getSend_plan()), smsPlanBean.getTemplate_id());
            logger.warn(str5, exception);
          } 
          continue;
        } 
        if (!IMSenderUtil.sendGSMMessage(arrayList.<String>toArray(new String[0]), hashMap1, smsPlanBean.getSend_plan(), smsPlanBean.getTemplate_id())) {
          logger.warn(String.format("subKey:%s 短信发送失败", new Object[] { str }));
          continue;
        } 
        logger.info(String.format("subKey:%s 短信发送成功", new Object[] { str }));
      } 
    } 
  }
  
  private void WriteSendLog(List<String> paramList, Map<String, Object> paramMap, String paramString1, String paramString2, String paramString3) {
    String str1 = String.format("%s %s", new Object[] { String.valueOf(paramMap.get("reciveDate")), String.valueOf(paramMap.get("content")) });
    ArrayList<String> arrayList = new ArrayList();
    StringBuilder stringBuilder = new StringBuilder("insert into sys_msg_content(CONTENT, SEND_PLAN_TIME, VARS_JSON, TEMPLATE_ID) VALUES(");
    stringBuilder.append("'").append(str1).append("',");
    stringBuilder.append(Calendar.getInstance().getTimeInMillis()).append(",");
    stringBuilder.append("'").append(JsonUtil.getJsonByObject(paramMap)).append("',");
    stringBuilder.append("'").append(paramString3).append("'");
    stringBuilder.append(")");
    try {
      this.jdbcClient.update(stringBuilder.toString());
    } catch (Exception exception) {
      exception.printStackTrace();
      logger.info("保存日志推送记录错误，sql：" + stringBuilder.toString());
      return;
    } 
    List<Map> list = this.jdbcClient.queryForList("select * from sys_msg_content where content='" + str1 + "'");
    if (list.size() == 0) {
      logger.info("未读取到保存的日志推送记录，内容：" + str1);
      return;
    } 
    String str2 = String.valueOf(((Map)list.get(0)).get("id"));
    for (String str : paramList) {
      stringBuilder = new StringBuilder("insert into sys_msg_history(CONTENT_ID, CREATE_TIME, MSG_TYPE, REASON, RECV_ADDRESS, SENDER_TIME, STATUS) VALUES(");
      stringBuilder.append("'").append(str2).append("',");
      stringBuilder.append("'").append(paramMap.get("reciveDate")).append("',");
      stringBuilder.append(0).append(",");
      stringBuilder.append("'").append(paramString1).append("',");
      stringBuilder.append("'").append(str).append("',");
      stringBuilder.append("'").append(paramMap.get("reciveDate")).append("',");
      stringBuilder.append(ParameterUtils.isEmptyOrNull(paramString1) ? 1 : 0).append(")");
      arrayList.add(stringBuilder.toString());
    } 
    if (arrayList.size() > 0)
      try {
        this.jdbcClient.update(arrayList);
      } catch (Exception exception) {
        exception.printStackTrace();
        logger.info("保存日志推送记录错误，表sys_msg_hstory：sql例子:" + (String)arrayList.get(0));
      }  
  }
  
  private boolean FACheck(String paramString, boolean paramBoolean) {
    boolean bool = true;
    Integer integer = Constants.getInteger("dms.sms.fa.send", Integer.valueOf(1));
    if (integer.equals(Integer.valueOf(1))) {
      if (paramBoolean)
        logger.info("FA测试线路判断是否发送"); 
      String str = "select status from real_scada_obj_dev where id = " + paramString;
      List<Map> list = this.rthdbDao.queryForList(str);
      if (list.size() == 0) {
        if (brkStatusMap.containsKey(paramString)) {
          if (!((Integer)brkStatusMap.get(paramString)).equals(Integer.valueOf(1))) {
            bool = false;
            if (paramBoolean)
              logger.info(String.format("读取设备%s实时状态失败，采用上次状态，上次状态为0，不发送短信", new Object[] { paramString })); 
          } else {
            bool = true;
          } 
        } else {
          brkStatusMap.put(paramString, Integer.valueOf(0));
          if (paramBoolean)
            logger.info(String.format("设备%s不在初始化开关列表，重新加入，设置默认状态为0，不发送短信", new Object[] { paramString })); 
          bool = false;
        } 
      } else {
        Integer integer1 = Integer.valueOf(String.valueOf(((Map)list.get(0)).get("status")));
        String str1 = Integer.toBinaryString(integer1.intValue());
        if (str1.length() < 13) {
          brkStatusMap.put(paramString, Integer.valueOf(1));
          bool = true;
          if (paramBoolean)
            logger.info(String.format("读取设备%s实时状态，当前状态为%d，正常发送短信", new Object[] { paramString, integer1 })); 
        } else if (str1.charAt(12) == '1') {
          brkStatusMap.put(paramString, Integer.valueOf(0));
          bool = false;
          if (paramBoolean)
            logger.info(String.format("读取设备%s实时状态，当前状态为%s，不发送短信", new Object[] { paramString, str1 })); 
        } else {
          brkStatusMap.put(paramString, Integer.valueOf(1));
          bool = true;
        } 
      } 
    } else if (paramBoolean) {
      logger.info("FA检测值被改为0，不检测FA线路挂测试牌情况");
    } 
    return bool;
  }
  
  private List<AlarmMsgBean> extractAlarmFromMsgContentNew(Map<String, Object> paramMap) {
    if (paramMap == null) {
      logger.info("短信内容为空");
      return null;
    } 
    ArrayList<AlarmMsgBean> arrayList = new ArrayList();
    Object object = paramMap.get("alarm_list");
    if (object == null || !(object instanceof List))
      return null; 
    List list = (List)object;
    if (!ParameterUtils.isEmptyOrNull(list)) {
      for (Map map : list) {
        Object object1 = map.get("origin_alarm");
        if (object1 == null)
          continue; 
        String str = JsonUtil.getJsonByObject(object1);
        AlarmMsgBean alarmMsgBean = (AlarmMsgBean)JsonUtil.getBeanByJson(str, AlarmMsgBean.class);
        if (alarmMsgBean.isValid())
          arrayList.add(alarmMsgBean); 
      } 
      if (ParameterUtils.isEmptyOrNull(arrayList))
        logger.info("未解析到短信内容，可能是CS告警结构体缺少inferName所致"); 
      return arrayList;
    } 
    return null;
  }
  
  private boolean isUsedDev(SmsPlanBean paramSmsPlanBean, String paramString, boolean paramBoolean) {
    if (paramSmsPlanBean.getDevs().contains(paramString)) {
      if (paramBoolean)
        logger.info(String.format("设备:%s是按设备订阅的，在订阅列表，不判断其他权限，直接发送短信", new Object[] { paramString })); 
      return true;
    } 
    String str1 = "";
    String str2 = "";
    if (paramString.startsWith("1021")) {
      String str = "select filter,container_id from obj_dev where id=" + paramString;
      List<Map> list = this.jdbcClient.queryForList(str);
      if (list.size() == 0) {
        if (paramBoolean)
          logger.info(String.format("设备%s在数据库没有找到", new Object[] { paramString })); 
        return false;
      } 
      Object object1 = ((Map)list.get(0)).get("filter");
      Object object2 = ((Map)list.get(0)).get("containerId");
      str2 = ParameterUtils.isEmptyOrNull(object1) ? "" : String.valueOf(object1);
      str1 = ParameterUtils.isEmptyOrNull(object2) ? "" : String.valueOf(object2);
      logger.debug(String.format("设备:%s  类型为:%s 容器:%s", new Object[] { paramString, str2, str1 }));
      if (str2.isEmpty() && (ParameterUtils.isEmptyOrNull(str1) || Long.valueOf(String.valueOf(object2)).longValue() < 0L)) {
        logger.debug(String.format("设备:%s 没有容器也没有类型，也没有被订阅，不发送短信", new Object[] { paramString }));
        return false;
      } 
    } else if (paramString.startsWith("1007")) {
      String str = "select container_id from con_feeder where id=" + paramString;
      List<Map> list = this.jdbcClient.queryForList(str);
      if (list.size() == 0) {
        if (paramBoolean)
          logger.info(String.format("馈线%s在数据库没有找到", new Object[] { paramString })); 
        return false;
      } 
      Object object = ((Map)list.get(0)).get("containerId");
      str1 = ParameterUtils.isEmptyOrNull(object) ? "" : String.valueOf(object);
    } 
    Integer integer = Constants.getInteger("dms.sms.auth", Integer.valueOf(0));
    if (str1.startsWith("1009") && paramString.startsWith("1021")) {
      if (headerBrkMap.containsKey(paramString) && integer.equals(Integer.valueOf(1))) {
        String str = headerBrkMap.get(paramString);
        if (((List)smsProcessBean.getUserFeeders().get(paramSmsPlanBean.getUser_id())).contains(str)) {
          String str6 = "-1";
          List<Map> list = this.jdbcClient.queryForList("select container_id from con_voltagelevel where id=" + str1);
          if (list.size() > 0)
            str6 = String.valueOf(((Map)list.get(0)).get("containerId")); 
          logger.info(String.format("电压等级%s的容器变电站为：%s", new Object[] { str1, str6 }));
          if (!paramSmsPlanBean.getdTypes().contains(str) && 
            !paramSmsPlanBean.getdTypes().contains(str6) && 
            !paramSmsPlanBean.getdTypes().contains(str2) && 
            !paramSmsPlanBean.getDevs().contains(paramString)) {
            if (paramBoolean)
              logger.info(String.format("[带权限验证]设备:%s 是馈线:%s的首开关,馈线在用户%d的权限中,但用户未订阅该设备或变电站或馈线或设备类型，不发送短信", new Object[] { paramString, str, paramSmsPlanBean.getUser_id() })); 
            return false;
          } 
          if (paramBoolean)
            logger.info(String.format("[带权限验证]设备:%s 是馈线:%s的首开关,馈线在用户%d的权限中,发送短信", new Object[] { paramString, str, paramSmsPlanBean.getUser_id() })); 
          return true;
        } 
        if (paramBoolean)
          logger.info(String.format("[带权限验证]设备:%s 是馈线:%s的首开关,馈线不在用户%d的权限，不发送短信", new Object[] { paramString, str, paramSmsPlanBean.getUser_id() })); 
        return false;
      } 
      if (paramBoolean)
        logger.info(String.format("设备:%s 不是首开关,容器不是馈线及变电站，按设备类型判断", new Object[] { paramString })); 
      if (!ParameterUtils.isEmptyOrNull(str2) && paramSmsPlanBean.getdTypes().contains(str2)) {
        if (paramBoolean)
          logger.info(String.format("[设备容器不是厂站或馈线也不是点的告警-按设备类型]设备:%s  类型为:%s 在用户%d的订阅列表", new Object[] { paramString, str2, paramSmsPlanBean.getUser_id() })); 
        return true;
      } 
      if (paramSmsPlanBean.getDevs().contains(paramString)) {
        if (paramBoolean)
          logger.info(String.format("[设备容器不是厂站或馈线也不是点的告警-没有设备类型，是单独订阅的设备]设备:%s  在用户%d的订阅列表", new Object[] { paramString, paramSmsPlanBean.getUser_id() })); 
        return true;
      } 
      if (paramBoolean)
        logger.info(String.format("[设备容器不是厂站或馈线也不是点的告警-按设备类型]设备:%s  类型为:%s 不在用户%d的订阅列表", new Object[] { paramString, str2, paramSmsPlanBean.getUser_id() })); 
    } 
    if (integer.intValue() == 0) {
      if (!ParameterUtils.isEmptyOrNull(str2) && paramSmsPlanBean.getdTypes().contains(str2)) {
        logger.debug(String.format("[不带权限验证-按设备类型]设备:%s  类型为:%s 在用户%d的订阅列表", new Object[] { paramString, str2, paramSmsPlanBean.getUser_id() }));
        return true;
      } 
      Map<String, Object> map1 = loadFeederAndStation("obj_dev", paramString);
      String str6 = map1.containsKey("fd") ? String.valueOf(map1.get("fd")) : "";
      String str7 = map1.containsKey("st") ? String.valueOf(map1.get("st")) : "";
      logger.debug(String.format("设备%s,馈线%s,变电站%s", new Object[] { paramString, str6, str7 }));
      if (!ParameterUtils.isEmptyOrNull(str6) && paramSmsPlanBean.getdTypes().contains(str6)) {
        logger.debug(String.format("[不带权限验证-按馈线]设备:%s  馈线为:%s 在用户%d的订阅列表", new Object[] { paramString, str6, paramSmsPlanBean.getUser_id() }));
        return true;
      } 
      if (!ParameterUtils.isEmptyOrNull(str7) && paramSmsPlanBean.getdTypes().contains(str7)) {
        logger.debug(String.format("[不带权限验证-按厂站]设备:%s  厂站为:%s 在用户%d的订阅列表", new Object[] { paramString, str7, paramSmsPlanBean.getUser_id() }));
        return true;
      } 
      logger.debug(String.format("[不带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 不在订阅列表", new Object[] { paramString, str2, str6, str7 }));
      return false;
    } 
    String str3 = "obj_dev";
    if (paramString.startsWith("1007"))
      str3 = "con_feeder"; 
    Map<String, Object> map = loadFeederAndStation(str3, paramString);
    String str4 = map.containsKey("fd") ? String.valueOf(map.get("fd")) : "";
    String str5 = map.containsKey("st") ? String.valueOf(map.get("st")) : "";
    logger.debug(String.format("设备%s,馈线%s,变电站%s", new Object[] { paramString, str4, str5 }));
    if (!ParameterUtils.isEmptyOrNull(str4) && paramSmsPlanBean.getdTypes().contains(str4)) {
      if (((List)smsProcessBean.getUserFeeders().get(paramSmsPlanBean.getUser_id())).contains(str4)) {
        if (paramBoolean)
          logger.info(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 馈线在用户%d的权限,发送短信", new Object[] { paramString, str2, str4, str5, paramSmsPlanBean.getUser_id() })); 
        return true;
      } 
      if (paramBoolean)
        logger.info(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 馈线或设备不在用户%d的权限，继续判断厂站的权限", new Object[] { paramString, str2, str4, str5, paramSmsPlanBean.getUser_id() })); 
    } else if (!ParameterUtils.isEmptyOrNull(str5) && paramSmsPlanBean.getdTypes().contains(str5)) {
      if (((List)smsProcessBean.getUserStations().get(paramSmsPlanBean.getUser_id())).contains(str5)) {
        if (paramBoolean)
          logger.info(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 厂站在用户%d的权限,发送短信", new Object[] { paramString, str2, str4, str5, paramSmsPlanBean.getUser_id() })); 
        return true;
      } 
      if (paramBoolean)
        logger.info(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 厂站不在用户%d的权限，继续判断设备类型", new Object[] { paramString, str2, str4, str5, paramSmsPlanBean.getUser_id() })); 
    } else if (!ParameterUtils.isEmptyOrNull(str2) && paramSmsPlanBean.getdTypes().contains(str2)) {
      if (((List)smsProcessBean.getUserFeeders().get(paramSmsPlanBean.getUser_id())).contains(str4) || ((List)smsProcessBean
        .getUserStations().get(paramSmsPlanBean.getUser_id())).contains(str5))
        return true; 
      logger.debug(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 设备在订阅列表但用户%d没有设备的权限", new Object[] { paramString, str2, str4, str5, paramSmsPlanBean.getUser_id() }));
    } else {
      logger.debug(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 不在用户%d 订阅列表或者没有权限", new Object[] { paramString, str2, str4, str5, paramSmsPlanBean.getUser_id() }));
    } 
    return false;
  }
  
  private Map<String, Object> loadFeederAndStation(String paramString1, String paramString2) {
    HashMap<Object, Object> hashMap = new HashMap<>();
    if (paramString1 == "con_feeder")
      hashMap.put("fd", paramString2); 
    List list = this.jdbcClient.queryForList("select container_id,container_tablename from " + paramString1 + " where id=" + paramString2);
    for (Map map : list) {
      String str1 = String.valueOf(map.get("containerTablename"));
      String str2 = String.valueOf(map.get("containerId"));
      if (ParameterUtils.isEmptyOrNull(str2) || ParameterUtils.isEmptyOrNull(str1))
        return (Map)hashMap; 
      if (str1.equals("con_feeder"))
        hashMap.put("fd", str2); 
      if (str1.equals("con_station")) {
        hashMap.put("st", str2);
        return (Map)hashMap;
      } 
      Map<String, Object> map1 = loadFeederAndStation(str1, str2);
      if (!ParameterUtils.isEmptyOrNull(map1.get("fd")))
        hashMap.put("fd", map1.get("fd")); 
      if (!ParameterUtils.isEmptyOrNull(map1.get("st")))
        hashMap.put("st", map1.get("st")); 
    } 
    return (Map)hashMap;
  }
}
